/* Decrio  EMInk-EM10.pdb̕\ */
/* Rexxg̐D                 */
/*                               *//*
   VRexxgĂ, \̕\B
   W͈̔:
      5' x 7.1' ... 1016C/C`  5x1016 7x1016 == 5080 7112

2000.3.11
   ꕔ̏񂪕Ȃ, ӂƋCtB
   EE r̃rbgȂ̂ (^^)

2001.3
   ΂B
   G[Ȃǂł̒~̂Ƃ̍sԍ\B

2002.9
   ϐ VREXX_HOME 𒲂ׂ[ɂ
   L[ꂽ chars() Ń`FbN[ɂ
*/
options translate('ETmode')
True = 1; False = 0;

/* load and initialize VREXX */
VHome = value('VREXX_HOME',, 'OS2ENVIRONMENT')
if VHome \== '' then do
   saveddir = Directory()
   call Directory VHome
end
call RxFuncAdd 'VInit', 'VRexx', 'VINIT'
Rc = VInit()
if symbol('saveddir') \== 'LIT' then
   call Directory saveddir
if Rc = 'ERROR' then signal Cleanup

signal on failure name Cleanup
signal on halt name Cleanup
signal on syntax name Cleanup

/* t@C𓾂 */
parse arg fname .
if fname = '' then do forever
   if pos('*', mask) == 0 then
      mask = FileSpec('P', fname)'*.pdb'

   btn = VFileBox('Decrio PDB ǂݍ', mask, name)
   if btn \== 'OK' then signal Cleanup
   mask = name.vstring

   fname = name.vstring
   if \ReadPDB(fname, 'Info. Rec.') then iterate

   parse var Info._HEAD str '0'x
   if str \== 'EMInk-EM10' then iterate

   say 't@CF' fname
   leave
end
else do
   if stream(fname, 'c', 'query exists') == '' then do
      if DBRight(fname, 1) \== '\' then fname = fname'\'
      fname = fname'EMInk-EM10.pdb'
      if stream(fname, 'c', 'query exists') == '' then do
         say 't@C('fname')Ȃ'
         signal Cleanup
      end
   end

   drop info.
   if \ReadPDB(fname, 'Info. Rec.') then do
      say 'PDB Ȃ ('fname')'
      signal Cleanup
   end

   parse var Info._HEAD str '0'x
   if str \== 'EMInk-EM10' then do
      say 'Decrio PDB Ȃ ('fname')'
      signal Cleanup
   end
end

if \ReadPDB(fname, 'Info. Rec.') then signal Cleanup

do forever
   say '[1`'rec.0 -1']: ԍ͂ĉB'
   do i = 1 to rec.0 -1
      n = length(rec.i)
      say right(i, 3)':'right(n, 6)'('n -8') Bytes'
   end
   pull n
   if \datatype(n, 'W') then signal Cleanup
   if n < 1 | n >= rec.0 then signal Cleanup

   position.left   = 15
   position.bottom =  5
   position.right  = 65
   position.top    = 95
   if \datatype(wid, 'W') then
      wid = VOpenWindow('EDF View', 'WHITE', position)

   call VClearWindow wid
   call EDFView wid, rec.n
end

/* terminate VREXX */
msg.0 = 1
msg.1 = 'I܂'
call VMsgBox 'EDF View', msg, 1 /* 1; OK */

SIGL = 0
Cleanup:
if SIGL > 0 then say 'stop at' SIGL

if datatype(wid, 'W') then
   call VCloseWindow wid

if RxFuncQuery('VExit') == 0 then
   call VExit

exit



EDFView: procedure
parse arg wid, ch +1+2+4 vct
if ch \== 'f0'x then do; trace ?R; say 'Not F0'; end;

lenW = 5*1016
lenH = 7*1016
p = 1
do forever
   ch = substr(vct, p, 1)
   select
      when ch == 'a1'x then nop
      when ch == 'f1'x then leave
   otherwise
      trace ?R
      say '???' c2x(ch)
   end
   parse value substr(vct, p +1, 6) with cnt +2 posx +2 posy +2
   p = p +7
   cnt = c2d(cnt)
   if cnt == 0 then do; trace ?R; say d2x(cnt); end;

   x = c2d(right(posx, 1)) *128 +c2d(left(posx, 1))
   y = c2d(right(posy, 1)) *128 +c2d(left(posy, 1))
   px.1 = x *1000 %lenW        /* graphicsW(x) */
   py.1 = 1000 - y *1000 %lenH /* graphicsW(y) */
   do i = 2 to cnt
      parse value substr(vct, p, 2) with cx +1 cy +1
      p = p +2

      dx = c2d(bitand(cx, '7f'x))
      if bitand(cx, '80'x) == '80'x then dx = -dx
      dy = c2d(bitand(cy, '7f'x))
      if bitand(cy, '80'x) == '80'x then dy = -dy

      x = x +dx
      y = y +dy
      px.i = x *1000 %lenW
      py.i = 1000 - y *1000 %lenH
   end

   if cnt == 1
      then call VDraw wid, 'PIXEL', px, py, 1
      else call VDraw wid, 'LINE', px, py, cnt

   if chars() > 0 then leave
end
return

ReadPDB: parse arg , ReadPDB; return ReadPDBCore(arg(1));
ReadPDBCore: procedure expose True False (ReadPDB)
parse var ReadPDB PdbInfo PdbRec .
parse arg fname
call stream fname, 'c', 'open read'
val = charin(fname,, chars(fname))
call stream fname, 'c', 'close'
if val == '' then return False
Head = left(val, 78)
cnt = c2d(right(Head, 2))
call value PdbInfo'_HEAD', Head
call value PdbRec'0', cnt
p = length(Head)
flgs = x2b(c2x(substr(Head, 33, 2)))
if substr(flgs, 16, 1)
   then do i = 1 to cnt
      parse var val +(p) hd +6 pr.i +4
      call value PdbRec''i'._HEAD', hd
      p = p +10
   end
   else do i = 1 to cnt
      parse var val +(p) pr.i +4 hd +4
      call value PdbRec''i'._HEAD', hd
      p = p +8
   end
p = length(val) +1
do i = cnt to 1 by -1
   n = c2d(pr.i) +1
   call value PdbRec''i, substr(val, n, p -n)
   p = n
end
v = substr(Head, 57, 4) /* -- sort field */
if v \== '00000000'x then do
   n = c2d(v) +1
   call value PdbInfo'_SORT', substr(val, n, p -n)
   p = n
end
v = substr(Head, 53, 4) /* -- app field */
if v \== '00000000'x then do
   n = c2d(v) +1
   call value PdbInfo'_APP', substr(val, n, p -n)
   p = n
end
return True

/**  End of Script  **/
